//-----------------------------------------------------------------------------
// USART Fuction Declaration
#define XTAL          						11059200      // XTAL frequency

#define BAUD_9600							0
#define BAUD_14400							1
#define BAUD_19200							2
#define BAUD_28800							3
#define BAUD_38400							4		
#define BAUD_57600							5		
#define BAUD_76800							6		
#define BAUD_115200							7

	
#ifdef _UART0_ENABLE
//------------------------------------------------------------------------------
// UART Defination
//------------------------------------------------------------------------------

//#define U0_printf(Value)					printf(Value)
#define U0_printf							printf

#define BAUDRATE_VAL_9600					9600
#define BAUDRATE_VAL_19200					19200
#define BAUDRATE_VAL_14400					14400
#define BAUDRATE_VAL_28800					28800
#define BAUDRATE_VAL_38400					38400
#define BAUDRATE_VAL_57600					57600
#define BAUDRATE_VAL_76800					76800
#define BAUDRATE_VAL_115200					115200

#define BAUDRATE_VAL_DEFAULT				BAUDRATE_VAL_57600

#define BAUD_RATE(xtal,baud,smod)       	(256L-xtal/(baud*smod*192L))
#define T2RELOAD(Baudrate)   				(65536-(XTAL/32/(Baudrate)))

#define SERIAL_MODE1                    	0x40  // SCON.6 and SCON.7
#define DOUBLE_BAUD_RATE                	0x80  // PCON.7
#define ENABLE_RECEIVE                  	0x10  // SCON.4

#define UART_RXINT_ENABLE           		0x80
#define UART_TXINT_ENABLE           		0x40
#define UART_RX_ENABLE              		0x10
#define UART_TX_ENABLE              		0x08

#define UART_RX_COMPLETE            		0x80
#define UART_TX_COMPLETE            		0x40
#define UART_DATA_EMPTY             		0x20

#define TXD0_SEL_EN							BIT1
#define RXD0_SEL_EN							BIT0
#define TXD1_SEL_EN							0x40
#define RXD1_SEL_EN							0x80


//------------------------------------------------------------------------------
// Serial Prot0 Utility Fuction Routine
#define u0_WaitForReceive()					
#define u0_RxData()		 					

#define _u0_TxData(Data)					
#define u0_WaitForSend()					

#define u0_IsReceiveData()					(RI_0)

void u0_baudrate(unsigned char baud);
void u0_hal_init(void);

void u0_TxData(unsigned char Data)
{
	//_u0_TxData(Data);
}


void u0_hal_init(void)
{
	// enable serial uart & receiver
	SCON0 |= SERIAL_MODE1 | ENABLE_RECEIVE | 0x02;

	Sbi(P3DDRL, TXD0_SEL_EN);
	Sbi(P3DDRL, RXD0_SEL_EN);
	
	// Use Timer 2 as baudrate generator
	T2CON   = 0x34;                   
}

void u0_baudrate(unsigned char baud)
{
	unsigned long BaudRate; 
		
	switch (baud)
	{
		case BAUD_9600:
			BaudRate = BAUDRATE_VAL_9600;
			break;
		case BAUD_14400:
			BaudRate = BAUDRATE_VAL_14400;
			break;		
			
		case BAUD_19200:
			BaudRate = BAUDRATE_VAL_19200;
			break;		
			
		case BAUD_28800:
			BaudRate = BAUDRATE_VAL_28800;
			break;	
				
		case BAUD_38400:
			BaudRate = BAUDRATE_VAL_38400;
			break;		
			
		case BAUD_57600:
			BaudRate = BAUDRATE_VAL_57600;
			break;
			
		case BAUD_76800:
			BaudRate = BAUDRATE_VAL_76800;
			break;
					
		case BAUD_115200:
			BaudRate = BAUDRATE_VAL_115200;
			break;		

		default :
			BaudRate = BAUDRATE_VAL_57600;						
			break;
	}	

  	RCAP2H  = (T2RELOAD(BaudRate) >> 8);        // baudrate reload factor
  	RCAP2L  = T2RELOAD(BaudRate);	
  	
}
#endif
