//=============================================================================
// Microcontroller Serial Ʈ  API Լ
// by (nexp76@naver.com)
// [serial.h]
//=============================================================================

/*
 - [2007.01.02] 
 -  Ŀ    ִ APIԼ  Ʈ
  - ø Ʈ APIԼ 
  - _UART0_ENABLE UART0
  
*/

#include "..\00_hal\serial_hal.h"

//------------------------------------------------------------------------------
// UART Defination
//------------------------------------------------------------------------------
#define BAUD_9600							0
#define BAUD_14400							1
#define BAUD_19200							2
#define BAUD_28800							3
#define BAUD_38400							4		
#define BAUD_57600							5		
#define BAUD_76800							6		
#define BAUD_115200							7	


#ifdef _UART0_ENABLE
//-----------------------------------------------------------------------------
// USART Fuction Declaration
unsigned char U0_IsReceiveData(void);
void U0_Init(unsigned char Baud);
void U0_SetBaud(unsigned char baud);
unsigned char U0_GetByte(void);
void U0_PutByte(unsigned char Data);
void U0_PutBuf(unsigned char *str, unsigned char len);
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Serial Prot0 Utility Fuction Routine
void U0_Init(unsigned char Baud)
{
	U0_SetBaud(Baud);
	
	u0_hal_init();
}

void U0_SetBaud(unsigned char baud)
{
	u0_baudrate(baud);
}

unsigned char U0_GetByte(void)
{
	u0_WaitForReceive();
	
	return u0_RxData();
}

void U0_PutByte(unsigned char Data)
{
	u0_WaitForSend();
	
	u0_TxData(Data);
}

void U0_PutBuf(unsigned char *str, unsigned char len)
{
	unsigned char i =0;
	
    for(i=0;i<len;i++)
    {
        U0_PutByte(*(str+i));
    }
}

void U0_PutStr(unsigned char *str)
{
    while(*str != 0)
    {
        U0_PutByte(*str);
        str++;
    }
}

unsigned char U0_IsReceiveData(void)
{
	return u0_IsReceiveData();
}
//------------------------------------------------------------------------------
#endif	//end UART0 ENABLE

